#ifndef __PORT_H__
#define __PORT_H__

sbit    DOWNLOAD    =   P3^2;
sbit    LED_POWER   =   P3^3;
sbit    SVCC_E0     =   P3^5;
sbit    SVCC_E1     =   P5^4;

sbit    STXD        =   P3^6;
sbit    SRXD        =   P3^7;
sbit    STXD2       =   P1^0;
sbit    SRXD2       =   P1^1;

#define SVCC_ON()           SVCC_E0 = 0;    \
                            SVCC_E1 = 1;    \
                            LED_POWER = 1;  \
                            STXD = 1;       \
                            SRXD = 1;       \
                            STXD2 = 1;      \
                            SRXD2 = 1
                            
#define SVCC_OFF()          SVCC_E0 = 1;    \
                            SVCC_E1 = 0;    \
                            LED_POWER = 0;  \
                            STXD = 0;       \
                            SRXD = 0;       \
                            STXD2 = 0;      \
                            SRXD2 = 0

#define PLED_MODE()         if (g_bOPTION_0 & 0x02)                 \
                            {                   /*ʹLED*/ \
                                P3M0 |= 0x08;   /*P3.3*/    \
                                P3M1 &= ~0x08;                      \
                            }                                       \
                            else                                    \
                            {                   /*ֹLED*/ \
                                P3M0 &= ~0x08;  /*P3.3*/    \
                                P3M1 |= 0x08;                       \
                            }

#define PSTXD_MODE()        if (g_bOPTION_0 & 0x04)                 \
                            {                                       \
                                P3M0 &= ~0x40;  /*P3.6׼˫*/    \
                                P3M1 &= ~0x40;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P3M0 &= ~0x40;  /*P3.6*/    \
                                P3M1 |= 0x40;                       \
                            }

#define PSTXD2_MODE()        if (g_bOPTION_0 & 0x08)                \
                            {                                       \
                                P1M0 &= ~0x01;  /*P1.0׼˫*/    \
                                P1M1 &= ~0x01;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P1M0 &= ~0x01;  /*P1.0*/    \
                                P1M1 |= 0x01;                       \
                            }

#define PSRXD_IDLEMODE()    if (g_bOPTION_0 & 0x10)                 \
                            {                                       \
                                P3M0 |= 0x80;   /*P3.7*/    \
                                P3M1 &= ~0x80;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P3M0 |= 0x80;   /*P3.7©*/    \
                                P3M1 |= 0x80;                       \
                            }

#define PSRXD2_IDLEMODE()   if (g_bOPTION_0 & 0x20)                 \
                            {                                       \
                                P1M0 |= 0x02;   /*P1.1*/    \
                                P1M1 &= ~0x02;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P1M0 |= 0x02;   /*P1.1©*/    \
                                P1M1 |= 0x02;                       \
                            }

#define PSRXD_ACTMODE()     if (g_bOPTION_0 & 0x40)                 \
                            {                                       \
                                P3M0 |= 0x80;   /*P3.7*/    \
                                P3M1 &= ~0x80;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P3M0 |= 0x80;   /*P3.7©*/    \
                                P3M1 |= 0x80;                       \
                            }

#define PSRXD2_ACTMODE()    if (g_bOPTION_0 & 0x80)                 \
                            {                                       \
                                P1M0 |= 0x02;   /*P1.1*/    \
                                P1M1 &= ~0x02;                      \
                            }                                       \
                            else                                    \
                            {                                       \
                                P1M0 |= 0x02;   /*P1.1©*/    \
                                P1M1 |= 0x02;                       \
                            }

#define PSTXD_BIDIR()       {                                       \
                                P3M0 &= ~0x40;  /*P3.6׼˫*/    \
                                P3M1 &= ~0x40;                      \
                            }

#define PRTXD_BIDIR()       {                                       \
                                P3M0 &= ~0x80;  /*P3.7׼˫*/    \
                                P3M1 &= ~0x80;                      \
                            }

#define PSTXD2_BIDIR()      {                                       \
                                P1M0 &= ~0x01;  /*P1.0׼˫*/    \
                                P1M1 &= ~0x01;                      \
                            }

#define PRTXD2_BIDIR()      {                                       \
                                P1M0 &= ~0x02;  /*P1.1׼˫*/    \
                                P1M1 &= ~0x02;                      \
                            }

#define UART1_SEL()         (!(g_bOPTION_1 & 0x02))

#define UART2_SEL()         (g_bOPTION_1 & 0x02)

extern BYTE g_bOPTION_0;
extern BYTE g_bOPTION_1;

#endif

